A portable, open-source, coherent noise-generating library for C++

Main Page | Modules | Class Hierarchy | Class List | File List | Class Members

# noise::module::Cache Class Reference
[Miscellaneous Modules]

`#include <cache.h>`

Inheritance diagram for noise::module::Cache:

List of all members.

## Detailed Description

Noise module that caches the last output value generated by a source module.

If an application passes an input value to the GetValue() method that differs from the previously passed-in input value, this noise module instructs the source module to calculate the output value. This value, as well as the ( x, y, z ) coordinates of the input value, are stored (cached) in this noise module.

If the application passes an input value to the GetValue() method that is equal to the previously passed-in input value, this noise module returns the cached output value without having the source module recalculate the output value.

If an application passes a new source module to the SetSourceModule() method, the cache is invalidated.

Caching a noise module is useful if it is used as a source module for multiple noise modules. If a source module is not cached, the source module will redundantly calculate the same output value once for each noise module in which it is included.

This noise module requires one source module.

## Public Member Functions

| Cache ()
| Constructor.
virtual int | GetSourceModuleCount () const
| Returns the number of source modules required by this noise module.
virtual double | GetValue (double x, double y, double z) const
| Generates an output value given the coordinates of the specified input value.
virtual void | SetSourceModule (int index, const Module &sourceModule)
| Connects a source module to this noise module.

## Protected Attributes

double | m_cachedValue
| The cached output value at the cached input value.
double | m_isCached
| Determines if a cached output value is stored in this noise module.
double | m_xCache
| x coordinate of the cached input value.
double | m_yCache
| y coordinate of the cached input value.
double | m_zCache
| z coordinate of the cached input value.

## Member Function Documentation

virtual int noise::module::Cache::GetSourceModuleCount | ( |  | ) | const`[inline, virtual]`

Returns the number of source modules required by this noise module.

Returns:
  The number of source modules required by this noise module.

Implements noise::module::Module.

double Cache::GetValue | ( | double | x,
|  | double | y,
|  | double | z
| ) | const`[virtual]`

Generates an output value given the coordinates of the specified input value.

Parameters:

  | x | The x coordinate of the input value.
  | y | The y coordinate of the input value.
  | z | The z coordinate of the input value.

Returns:
  The output value.

Precondition:
  All source modules required by this noise module have been passed to the SetSourceModule() method.

Before an application can call this method, it must first connect all required source modules via the SetSourceModule() method. If these source modules are not connected to this noise module, this method raises a debug assertion.

To determine the number of source modules required by this noise module, call the GetSourceModuleCount() method.

Implements noise::module::Module.

virtual void noise::module::Cache::SetSourceModule | ( | int | index,
|  | const Module & | sourceModule
| ) | `[inline, virtual]`

Connects a source module to this noise module.

Parameters:

  | index | An index value to assign to this source module.
  | sourceModule | The source module to attach.

Precondition:
  The index value ranges from 0 to one less than the number of source modules required by this noise module.

Exceptions:

  | noise::ExceptionInvalidParam | An invalid parameter was specified; see the preconditions for more information.

A noise module mathematically combines the output values from the source modules to generate the value returned by GetValue().

The index value to assign a source module is a unique identifier for that source module. If an index value has already been assigned to a source module, this noise module replaces the old source module with the new source module.

Before an application can call the GetValue() method, it must first connect all required source modules. To determine the number of source modules required by this noise module, call the GetSourceModuleCount() method.

This source module must exist throughout the lifetime of this noise module unless another source module replaces that source module.

A noise module does not modify a source module; it only modifies its output values.

Reimplemented from noise::module::Module.

The documentation for this class was generated from the following files:

- cache.h
- cache.cpp